> For the complete documentation index, see [llms.txt](https://docs.pandastack.io/v1/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.pandastack.io/v1/getting-started/platform/conatinered-website.md).

# Conatinered Website

This guide walks you through deploying and managing containerized applications on PandaStack Platform. Following features are available.&#x20;

## Supported Runtimes

* Node.js
* Python
* Go
* Docker

## Deployment Steps

### 1. Project Setup

1. Navigate to <a href="https://dashboard.pandastack.io/projects" class="button primary">Project Dashboard</a>
2. Click <a href="https://dashboard.pandastack.io/projects/configure-account" class="button primary">Create New Project</a>
3. Select "**Run as Container**" as project type
4. Configure basic settings:
   * Project name (4-12 characters, lowercase, hyphens allowed)
   * Select repository branch
   * Choose runtime (Node.js, Python, Go, Docker)
   * Select deployment region (EU, US, ASIA)

### 2. Build Configuration

#### Node.js

```bash
# Build Command Example
npm run build

# Start Command Example
npm start
```

#### Python

```bash
# Build Command Example
pip install -r requirements.txt

# Start Command Example
gunicorn your_application.wsgi
```

#### Go

```bash
# Build Command Example
go build -o main ./cmd/app

# Start Command Example
./main

# Default Health Check Path
/health
```

#### Docker

* Docker build context directory (default: ./)
* Dockerfile path (default: ./Dockerfile)
* Registry credentials for private registries
* Health check path configuration

## Resource Management

### Resource Tiers

* Free Tier (Limited resources)
* Standard Tier (Production ready)
* Compute-Optimized (C1/C2)
* Memory-Optimized (M1/M2)

### Auto-Scaling Configuration

```json
{
    "enabled": true,
    "minReplicas": 1,
    "maxReplicas": 5,
    "targetCPU": 80,
    "targetMemory": 70
}
```

### Storage Options

NVMe Disk sizes:

* No disk (default)
* 0.5 GB
* 1 GB
* 2 GB
* 3 GB
* 4 GB
* 5 GB

{% hint style="info" %}
Note: PVC disk  and auto-scaling is not available in free tier. Make sure you upgrade if you want to utilise those features.
{% endhint %}

## Environment Management

### Environment Variables

1. Direct Input:
   * Key-value pairs
   * Secure storage
   * Runtime access
2. Bulk Import:
   * Import from .env file
   * Multiple variables
   * Automatic parsing

### Secret Files

* Store sensitive configuration
* Environment files
* Private keys
* Access credentials

## Project Management

### Status Control

* Start/Pause project
  * You can start an pause the project as required. Starting and Pausing a project **may impact the cost of the project**.&#x20;
* Monitor status
  * Live deployment status will be available to users for all deployments.&#x20;
* View deployment history
  * Users can view the deployment history at <https://dashboard.pandastack.io/projects/>${name\_of\_project}

### Deployment Options

1. Manual Deployment:
   * Latest commit
   * Specific commit
   * Branch selection
2. Auto Deployment:
   * Deploy on push
   * Branch-based rules
   * PR preview `(Coming soon)`

### Health Monitoring

* Custom health check paths

## Docker Integration

### Registry Configuration

* Private registry support
* Credential management
* Secure image pulling
* Version control

### Build Settings

1. Context Configuration:
   * Build context directory
   * Dockerfile location
   * Build arguments
2. Runtime Settings:
   * Container commands
   * Environment variables
   * Volume mounts(PVCs)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pandastack.io/v1/getting-started/platform/conatinered-website.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
